unit libext2fs;

interface

uses windows, types, vv_io;

const
   EXT2_ET_BASE                             = 2133571328;
   EXT2_ET_MAGIC_EXT2FS_FILSYS              = 2133571329;
   EXT2_ET_MAGIC_BADBLOCKS_LIST             = 2133571330;
   EXT2_ET_MAGIC_BADBLOCKS_ITERATE          = 2133571331;
   EXT2_ET_MAGIC_INODE_SCAN                 = 2133571332;
   EXT2_ET_MAGIC_IO_CHANNEL                 = 2133571333;
   EXT2_ET_MAGIC_UNIX_IO_CHANNEL            = 2133571334;
   EXT2_ET_MAGIC_IO_MANAGER                 = 2133571335;
   EXT2_ET_MAGIC_BLOCK_BITMAP               = 2133571336;
   EXT2_ET_MAGIC_INODE_BITMAP               = 2133571337;
   EXT2_ET_MAGIC_GENERIC_BITMAP             = 2133571338;
   EXT2_ET_MAGIC_TEST_IO_CHANNEL            = 2133571339;
   EXT2_ET_MAGIC_DBLIST                     = 2133571340;
   EXT2_ET_MAGIC_ICOUNT                     = 2133571341;
   EXT2_ET_MAGIC_PQ_IO_CHANNEL              = 2133571342;
   EXT2_ET_MAGIC_EXT2_FILE                  = 2133571343;
   EXT2_ET_MAGIC_E2IMAGE                    = 2133571344;
   EXT2_ET_MAGIC_INODE_IO_CHANNEL           = 2133571345;
   EXT2_ET_MAGIC_RESERVED_9                 = 2133571346;
   EXT2_ET_BAD_MAGIC                        = 2133571347;
   EXT2_ET_REV_TOO_HIGH                     = 2133571348;
   EXT2_ET_RO_FILSYS                        = 2133571349;
   EXT2_ET_GDESC_READ                       = 2133571350;
   EXT2_ET_GDESC_WRITE                      = 2133571351;
   EXT2_ET_GDESC_BAD_BLOCK_MAP              = 2133571352;
   EXT2_ET_GDESC_BAD_INODE_MAP              = 2133571353;
   EXT2_ET_GDESC_BAD_INODE_TABLE            = 2133571354;
   EXT2_ET_INODE_BITMAP_WRITE               = 2133571355;
   EXT2_ET_INODE_BITMAP_READ                = 2133571356;
   EXT2_ET_BLOCK_BITMAP_WRITE               = 2133571357;
   EXT2_ET_BLOCK_BITMAP_READ                = 2133571358;
   EXT2_ET_INODE_TABLE_WRITE                = 2133571359;
   EXT2_ET_INODE_TABLE_READ                 = 2133571360;
   EXT2_ET_NEXT_INODE_READ                  = 2133571361;
   EXT2_ET_UNEXPECTED_BLOCK_SIZE            = 2133571362;
   EXT2_ET_DIR_CORRUPTED                    = 2133571363;
   EXT2_ET_SHORT_READ                       = 2133571364;
   EXT2_ET_SHORT_WRITE                      = 2133571365;
   EXT2_ET_DIR_NO_SPACE                     = 2133571366;
   EXT2_ET_NO_INODE_BITMAP                  = 2133571367;
   EXT2_ET_NO_BLOCK_BITMAP                  = 2133571368;
   EXT2_ET_BAD_INODE_NUM                    = 2133571369;
   EXT2_ET_BAD_BLOCK_NUM                    = 2133571370;
   EXT2_ET_EXPAND_DIR_ERR                   = 2133571371;
   EXT2_ET_TOOSMALL                         = 2133571372;
   EXT2_ET_BAD_BLOCK_MARK                   = 2133571373;
   EXT2_ET_BAD_BLOCK_UNMARK                 = 2133571374;
   EXT2_ET_BAD_BLOCK_TEST                   = 2133571375;
   EXT2_ET_BAD_INODE_MARK                   = 2133571376;
   EXT2_ET_BAD_INODE_UNMARK                 = 2133571377;
   EXT2_ET_BAD_INODE_TEST                   = 2133571378;
   EXT2_ET_FUDGE_BLOCK_BITMAP_END           = 2133571379;
   EXT2_ET_FUDGE_INODE_BITMAP_END           = 2133571380;
   EXT2_ET_BAD_IND_BLOCK                    = 2133571381;
   EXT2_ET_BAD_DIND_BLOCK                   = 2133571382;
   EXT2_ET_BAD_TIND_BLOCK                   = 2133571383;
   EXT2_ET_NEQ_BLOCK_BITMAP                 = 2133571384;
   EXT2_ET_NEQ_INODE_BITMAP                 = 2133571385;
   EXT2_ET_BAD_DEVICE_NAME                  = 2133571386;
   EXT2_ET_MISSING_INODE_TABLE              = 2133571387;
   EXT2_ET_CORRUPT_SUPERBLOCK               = 2133571388;
   EXT2_ET_BAD_GENERIC_MARK                 = 2133571389;
   EXT2_ET_BAD_GENERIC_UNMARK               = 2133571390;
   EXT2_ET_BAD_GENERIC_TEST                 = 2133571391;
   EXT2_ET_SYMLINK_LOOP                     = 2133571392;
   EXT2_ET_CALLBACK_NOTHANDLED              = 2133571393;
   EXT2_ET_BAD_BLOCK_IN_INODE_TABLE         = 2133571394;
   EXT2_ET_UNSUPP_FEATURE                   = 2133571395;
   EXT2_ET_RO_UNSUPP_FEATURE                = 2133571396;
   EXT2_ET_LLSEEK_FAILED                    = 2133571397;
   EXT2_ET_NO_MEMORY                        = 2133571398;
   EXT2_ET_INVALID_ARGUMENT                 = 2133571399;
   EXT2_ET_BLOCK_ALLOC_FAIL                 = 2133571400;
   EXT2_ET_INODE_ALLOC_FAIL                 = 2133571401;
   EXT2_ET_NO_DIRECTORY                     = 2133571402;
   EXT2_ET_TOO_MANY_REFS                    = 2133571403;
   EXT2_ET_FILE_NOT_FOUND                   = 2133571404;
   EXT2_ET_FILE_RO                          = 2133571405;
   EXT2_ET_DB_NOT_FOUND                     = 2133571406;
   EXT2_ET_DIR_EXISTS                       = 2133571407;
   EXT2_ET_UNIMPLEMENTED                    = 2133571408;
   EXT2_ET_CANCEL_REQUESTED                 = 2133571409;
   EXT2_ET_FILE_TOO_BIG                     = 2133571410;
   EXT2_ET_JOURNAL_NOT_BLOCK                = 2133571411;
   EXT2_ET_NO_JOURNAL_SB                    = 2133571412;
   EXT2_ET_JOURNAL_TOO_SMALL                = 2133571413;
   EXT2_ET_JOURNAL_UNSUPP_VERSION           = 2133571414;
   EXT2_ET_LOAD_EXT_JOURNAL                 = 2133571415;
   EXT2_ET_NO_JOURNAL                       = 2133571416;
   EXT2_ET_DIRHASH_UNSUPP                   = 2133571417;
   EXT2_ET_BAD_EA_BLOCK_NUM                 = 2133571418;
   EXT2_ET_TOO_MANY_INODES                  = 2133571419;
   EXT2_ET_NOT_IMAGE_FILE                   = 2133571420;
   EXT2_ET_RES_GDT_BLOCKS                   = 2133571421;
   EXT2_ET_RESIZE_INODE_CORRUPT             = 2133571422;
   EXT2_ET_SET_BMAP_NO_IND                  = 2133571423;

   // Flags for the ext2_filsys structure and for ext2fs_open()
   EXT2_FLAG_RW			      = $0001;
   EXT2_FLAG_CHANGED		      = $0002;
   EXT2_FLAG_DIRTY			   = $0004;
   EXT2_FLAG_VALID			   = $0008;
   EXT2_FLAG_IB_DIRTY		   = $0010;
   EXT2_FLAG_BB_DIRTY		   = $0020;
   EXT2_FLAG_SWAP_BYTES		   = $0040;
   EXT2_FLAG_SWAP_BYTES_READ	= $0080;
   EXT2_FLAG_SWAP_BYTES_WRITE	= $0100;
   EXT2_FLAG_MASTER_SB_ONLY	= $0200;
   EXT2_FLAG_FORCE			   = $0400;
   EXT2_FLAG_SUPER_ONLY		   = $0800;
   EXT2_FLAG_JOURNAL_DEV_OK	= $1000;
   EXT2_FLAG_IMAGE_FILE		   = $2000;

   // inode block counts
   EXT2_NDIR_BLOCKS  = 12;
 	EXT2_IND_BLOCK    = EXT2_NDIR_BLOCKS;
 	EXT2_DIND_BLOCK   = EXT2_IND_BLOCK   + 1;
   EXT2_TIND_BLOCK   = EXT2_DIND_BLOCK  + 1;
   EXT2_N_BLOCKS	   = EXT2_TIND_BLOCK  + 1;

   // Special inode numbers
   EXT2_BAD_INO		   = 1;	//* Bad blocks inode */
   EXT2_ROOT_INO		   = 2;	//* Root inode */
   EXT2_ACL_IDX_INO	   = 3;	//* ACL inode */
   EXT2_ACL_DATA_INO	   = 4;	//* ACL inode */
   EXT2_BOOT_LOADER_INO	= 5;	//* Boot loader inode */
   EXT2_UNDEL_DIR_INO	= 6;	//* Undelete directory inode */
   EXT2_RESIZE_INO		= 7;	//* Reserved group descriptors inode */
   EXT2_JOURNAL_INO	   = 8;	//* Journal inode */

   // Flags for link
   EXT2_FT_UNKNOWN		= 0;
   EXT2_FT_REG_FILE	   = 1;
   EXT2_FT_DIR		      = 2;
   EXT2_FT_CHRDEV		   = 3;
   EXT2_FT_BLKDEV		   = 4;
   EXT2_FT_FIFO		   = 5;
   EXT2_FT_SOCK		   = 6;
   EXT2_FT_SYMLINK		= 7;

   EXT2_FT_MAX		      = 8;



   // these are inode mode flags, taken from stat.h
   S_IFMT   = $F000; // format mask
   S_IFSOCK = $C000; // socket
   S_IFLNK  = $A000; // symbolic link
   S_IFREG  = $8000; // regular file
   S_IFBLK  = $6000; // block device
   S_IFDIR  = $4000; // directory
   S_IFCHR  = $2000; // character device
   S_IFIFO  = $1000; // fifo

   S_ISUID  = $0800; // SUID
   S_ISGID  = $0400; // SGID
   S_ISVTX  = $0200; // sticky bit

   S_IRWXU  = $01C0; // user mask
   S_IRUSR  = $0100;
   S_IWUSR  = $0080;
   S_IXUSR  = $0040;

   S_IRWXG  = $0038; // group mask
   S_IRGRP  = $0020;
   S_IWGRP  = $0010;
   S_IXGRP  = $0008;

   S_IRWXO  = $0007; // other mask
   S_IROTH  = $0004;
   S_IWOTH  = $0002;
   S_IXOTH  = $0001;


// Inode flags
   EXT2_SECRM_FL			= $00000001; //* Secure deletion */
   EXT2_UNRM_FL			= $00000002; //* Undelete */
   EXT2_COMPR_FL			= $00000004; //* Compress file */
   EXT2_SYNC_FL			= $00000008; //* Synchronous updates */
   EXT2_IMMUTABLE_FL		= $00000010; //* Immutable file */
   EXT2_APPEND_FL			= $00000020; //* writes to file may only append */
   EXT2_NODUMP_FL			= $00000040; //* do not dump file */
   EXT2_NOATIME_FL		= $00000080; //* do not update atime */
   // Reserved for compression usage... */
   EXT2_DIRTY_FL			= $00000100;
   EXT2_COMPRBLK_FL		= $00000200; //* One or more compressed clusters */
   EXT2_NOCOMPR_FL		= $00000400; //* Access raw compressed data */
   EXT2_ECOMPR_FL			= $00000800; //* Compression error */
   // End compression flags --- maybe not all used */
   EXT2_BTREE_FL			= $00001000; //* btree format dir */
   EXT2_INDEX_FL			= $00001000; //* hash-indexed directory */
   EXT2_IMAGIC_FL			= $00002000;
   EXT3_JOURNAL_DATA_FL	= $00004000; //* file data should be journaled */
   EXT2_NOTAIL_FL			= $00008000; //* file tail should not be merged */
   EXT2_DIRSYNC_FL 		= $00010000; //* Synchronous directory modifications */
   EXT2_TOPDIR_FL			= $00020000; //* Top of directory hierarchies*/
   EXT3_EXTENTS_FL 		= $00080000; //* Inode uses extents */
   EXT2_RESERVED_FL		= $80000000; //* reserved for ext2 lib */

   EXT2_FL_USER_VISIBLE		 = $0003DFFF; //* User visible flags */
   EXT2_FL_USER_MODIFIABLE	 = $000080FF; //* User modifiable flags */


// Return flags for the directory iterator functions
   DIRENT_CHANGED	= 1;
   DIRENT_ABORT	= 2;
   DIRENT_ERROR	= 3;

// Directory iterator flags
   DIRENT_FLAG_INCLUDE_EMPTY	   = 1;
   DIRENT_FLAG_INCLUDE_REMOVED	= 2;

   DIRENT_DOT_FILE		= 1;
   DIRENT_DOT_DOT_FILE	= 2;
   DIRENT_OTHER_FILE	   = 3;
   DIRENT_DELETED_FILE	= 4;

// ext2_fileio definitions
   EXT2_FILE_WRITE      = 1;
   EXT2_FILE_CREATE     = 2;

   // seek whence
   EXT2_SEEK_SET	 = 0;
   EXT2_SEEK_CUR	 = 1;
   EXT2_SEEK_END	 = 2; // Don't use this, I think there is a bug

  EXT2_SUPER_MAGIC : USHORT =	$EF53;
  EXT2_SUPER_MAGIC_SPARSE : USHORT = $FFFF;

  EXT2_GOOD_OLD_REV = 0;  //* The good old (original) format */
  EXT2_DYNAMIC_REV  = 1;  //* V2 format w/ dynamic inode sizes */

type

   ext2_ino_t  = U32;
{
   errcode_t   = Longint;

   io_manager = record
    magic         : errcode_t;
    name          : PChar;
    open          : pointer;
    close         : pointer;
    set_blksize   : pointer;
    read_blk      : pointer;
    write_blk     : pointer;
    flush         : pointer;
    write_byte    : pointer;
    set_option    : pointer;
    reserved: array[1..14] of Integer;
   end;

   Pio_manager = ^io_manager;

   io_channel = record
    magic         : errcode_t;
    io_manager    : Pio_manager;
    name          : PChar;
    block_size    : Integer;
    read_error    : Pointer;
    write_error   : Pointer;
    refcount      : Integer;
    flags         : Integer;
    reserved      : array[1..14] of Integer;
    priv_data     : Pointer;
    app_data      : Pointer;
   end;
   
   Pio_channel  = ^io_channel;
   PPio_channel = ^Pio_channel;        }

type ext2_super_block = record
	s_inodes_count       : U32; // Inodes count
	s_blocks_count       : U32;	// Blocks count */
	s_r_blocks_count     : U32;	// Reserved blocks count */
	s_free_blocks_count  : U32; // Free blocks count */
	s_free_inodes_count  : U32; // Free inodes count */
	s_first_data_block   : U32;	// First Data Block */
	s_log_block_size     : U32;	// Block size */
	s_log_frag_size      : S32;  // Fragment size */
	s_blocks_per_group   : U32;	// # Blocks per group */
	s_frags_per_group    : U32;	// # Fragments per group */
	s_inodes_per_group   : U32;	// # Inodes per group */
	s_mtime              : U32; // Mount time */
	s_wtime              : U32;	// Write time */
	s_mnt_count          : U16;// Mount count */
	s_max_mnt_count      : S16;	// Maximal mount count */
	s_magic              : U16;// Magic signature */
	s_state              : U16;// File system state */
	s_errors             : U16;// Behaviour when detecting errors */
	s_pad                : U16;
	s_lastcheck          : U32; // time of last check */
	s_checkinterval      : U32;	// max. time between checks */
	s_creator_os         : U32;	// OS */
	s_rev_level          : U32;	// Revision level */

	s_def_resuid         : U16;// Default uid for reserved blocks */
	s_def_resgid         : U16;// Default gid for reserved blocks */

   /////////////////////////////////////
   // These are only for revision 1

	s_first_ino           : U32; // First non-reserved inode */
	s_inode_size          : U16;// size of inode structure */
	s_block_group_nr      : U16;// block group # of this superblock */
	s_feature_compat      : U32; // compatible feature set */
	s_feature_incompat    : U32; // incompatible feature set */
	s_feature_ro_compat   : U32; // readonly-compatible feature set */
	s_uuid                : array [0..15] of U8; // 128-bit uuid for volume */
	s_volume_name         : array [0..15] of CHAR;  // volume name */
	s_last_mounted        : array [0..63] of CHAR;  // directory where last mounted */
	s_algorithm_usage_bitmap : U32; // For compression */
	// * Performance hints.  Directory preallocation should only
	// * happen if the EXT2_COMPAT_PREALLOC flag is on.
	s_prealloc_blocks     : U8;	// Nr of blocks to try to preallocate*/
	s_prealloc_dir_blocks : U8; // Nr to preallocate for dirs */
	s_reserved_gdt_blocks : U16;
	s_reserved : array [0..203] of ULONG;	// Padding to the end of the block */

 end;
 Pext2_super_block = ^ext2_super_block;

   struct_ext2_filsys = record
    magic         : errcode_t;
    io_channel    : Pio_channel;
    flags         : Integer;
    name          : PChar;
    super         : Pext2_super_block;
    block_size    : Integer;
    frag_size     : Integer;


    reserved : array[1..140] of Char; // total size should be 140
   end;

   Pext2_filsys  = ^struct_ext2_filsys;
   PPext2_filsys = ^Pext2_filsys;

  ext2_dir_entry = record
   inode     : U32;
   rec_len   : U16;
   name_len  : U8;
   file_type : U8;
   name      : array[0..0] of Char;
  end;
  Pext2_dir_entry = ^ext2_dir_entry;

  ext2_inode = packed record
    	i_mode         : USHORT;	// File mode */
	 	i_uid          : USHORT;	// Owner Uid */
	  	i_size         : ULONG;		// Size in bytes */
	  	i_atime        : ULONG;		// Access time */
	  	i_ctime        : ULONG;		// Creation time */
	  	i_mtime        : ULONG;		// Modification time */
	  	i_dtime        : ULONG;		// Deletion Time */
	 	i_gid          : USHORT;	// Group Id */
	 	i_links_count  : USHORT;	// Links count */
	  	i_blocks       : ULONG;		// Blocks count */
	  	i_flags        : ULONG;		// File flags */

		l_i_reserved1  : ULONG;    // OS dependent 1 */

	  	i_block        : array [1..EXT2_N_BLOCKS] of ULONG;	// Pointers to blocks */
	  	i_version      : ULONG;    // File version (for NFS) */
	  	i_file_acl     : ULONG;		// File ACL */
	  	i_dir_acl      : ULONG;		// Directory ACL or High part of file size */
	  	i_faddr        : ULONG;		// Fragment address */

		l_i_frag       : UCHAR;		// Fragment number */
      l_i_fsize      : UCHAR;		// Fragment size */
		i_pad1         : USHORT;
//		l_i_reserved2 : array[1..2] of ULONG;
      l_i_uid_high   : U16;
      l_i_gid_high   : U16;
      l_i_reserved2  : U32;
  end;

  ext2_inode_large = packed record
      i_mode         : U16;
      i_uid          : U16;
      i_size         : U32;
      i_atime        : U32;
      i_ctime        : U32;
      i_mtime        : U32;
      i_dtime        : U32;
      i_gid          : U16;
      i_links_count  : U16;
      i_blocks       : U32;
      i_flags        : U32;
      l_i_reserved1  : U32;
	  	i_block        : array [1..EXT2_N_BLOCKS] of U32;
      i_generation   : U32;
      i_file_acl     : U32;
      i_dir_acl      : U32;
      i_faddr        : U32;
      l_i_frag       : U8;
      l_i_fsize      : U8;
      i_pad1         : U16;
      l_i_uid_high   : U16;
      l_i_gid_high   : U16;
      l_i_reserved2  : U32;
      i_extra_isize  : U16;
      i_pad2         : U16;
  end;
  Pext2_inode = ^ext2_inode;
  Aext2_inode = array[0..0] of ext2_inode;

  blk_t = U32;
  Pblk_t = ^blk_t;

   ext2_file_t = record
      magic       : errcode_t;
      fs          : Pext2_filsys;
      ino         : ext2_ino_t;
      inode       : ext2_inode;
      flags       : Integer;
      pos         : Int64;
      blockno     : blk_t;
      physblock   : blk_t;
      buffer      : PChar;
   end;
   Pext2_file_t = ^ext2_file_t;
   PPext2_file_t = ^Pext2_file_t;


// alloc_sb.c
function ext2fs_new_inode(fs : Pext2_filsys; dir : ext2_ino_t; mode : integer; map : {ext2fs_inode_bitmap} pointer; inode : Pext2_inode) : errcode_t; cdecl;
{extern errcode_t ext2fs_new_block(ext2_filsys fs, blk_t goal, ext2fs_block_bitmap map, blk_t *ret);
extern errcode_t ext2fs_get_free_blocks(ext2_filsys fs, blk_t start,	blk_t finish, int num, ext2fs_block_bitmap map,	blk_t *ret);
extern errcode_t ext2fs_alloc_block(ext2_filsys fs, blk_t goal, char *block_buf, blk_t *ret);
}
// alloc_stats.c
procedure ext2fs_inode_alloc_stats(fs : Pext2_filsys; ino : ext2_ino_t; inuse : Integer); cdecl;
//void ext2fs_inode_alloc_stats2(ext2_filsys fs, ext2_ino_t ino, int inuse, int isdir);
procedure ext2fs_block_alloc_stats(ps : Pext2_filsys; blk : blk_t; inuse : Integer); cdecl;
{
// alloc_tables.c
extern errcode_t ext2fs_allocate_tables(ext2_filsys fs);
extern errcode_t ext2fs_allocate_group_table(ext2_filsys fs, dgrp_t group, ext2fs_block_bitmap bmap);

// badblocks.c
extern errcode_t ext2fs_u32_list_create(ext2_u32_list *ret, int size);
extern errcode_t ext2fs_u32_list_add(ext2_u32_list bb, __u32 blk);
extern int ext2fs_u32_list_find(ext2_u32_list bb, __u32 blk);
extern int ext2fs_u32_list_test(ext2_u32_list bb, blk_t blk);
extern errcode_t ext2fs_u32_list_iterate_begin(ext2_u32_list bb, ext2_u32_iterate *ret);
extern int ext2fs_u32_list_iterate(ext2_u32_iterate iter, blk_t *blk);
extern void ext2fs_u32_list_iterate_end(ext2_u32_iterate iter);
extern errcode_t ext2fs_u32_copy(ext2_u32_list src, ext2_u32_list *dest);
extern int ext2fs_u32_list_equal(ext2_u32_list bb1, ext2_u32_list bb2);

extern errcode_t ext2fs_badblocks_list_create(ext2_badblocks_list *ret, int size);
extern errcode_t ext2fs_badblocks_list_add(ext2_badblocks_list bb, blk_t blk);
extern int ext2fs_badblocks_list_test(ext2_badblocks_list bb, blk_t blk);
extern int ext2fs_u32_list_del(ext2_u32_list bb, __u32 blk);
extern void ext2fs_badblocks_list_del(ext2_u32_list bb, __u32 blk);
extern errcode_t ext2fs_badblocks_list_iterate_begin(ext2_badblocks_list bb, ext2_badblocks_iterate *ret);
extern int ext2fs_badblocks_list_iterate(ext2_badblocks_iterate iter, blk_t *blk);
extern void ext2fs_badblocks_list_iterate_end(ext2_badblocks_iterate iter);
extern errcode_t ext2fs_badblocks_copy(ext2_badblocks_list src, ext2_badblocks_list *dest);
extern int ext2fs_badblocks_equal(ext2_badblocks_list bb1, ext2_badblocks_list bb2);
extern int ext2fs_u32_list_count(ext2_u32_list bb);

// bb_compat
extern errcode_t badblocks_list_create(badblocks_list *ret, int size);
extern errcode_t badblocks_list_add(badblocks_list bb, blk_t blk);
extern int badblocks_list_test(badblocks_list bb, blk_t blk);
extern errcode_t badblocks_list_iterate_begin(badblocks_list bb, badblocks_iterate *ret);
extern int badblocks_list_iterate(badblocks_iterate iter, blk_t *blk);
extern void badblocks_list_iterate_end(badblocks_iterate iter);
extern void badblocks_list_free(badblocks_list bb);

// bb_inode.c
extern errcode_t ext2fs_update_bb_inode(ext2_filsys fs, ext2_badblocks_list bb_list);

// bitmaps.c
extern errcode_t ext2fs_write_inode_bitmap(ext2_filsys fs);
extern errcode_t ext2fs_write_block_bitmap (ext2_filsys fs);
extern errcode_t ext2fs_read_inode_bitmap (ext2_filsys fs);
extern errcode_t ext2fs_read_block_bitmap(ext2_filsys fs);
extern errcode_t ext2fs_allocate_generic_bitmap(__u32 start, __u32 end,	__u32 real_end, const char *descr, ext2fs_generic_bitmap *ret);
extern errcode_t ext2fs_allocate_block_bitmap(ext2_filsys fs, const char *descr, ext2fs_block_bitmap *ret);
extern errcode_t ext2fs_allocate_inode_bitmap(ext2_filsys fs, const char *descr, ext2fs_inode_bitmap *ret);
extern errcode_t ext2fs_fudge_inode_bitmap_end(ext2fs_inode_bitmap bitmap, ext2_ino_t end, ext2_ino_t *oend);
extern errcode_t ext2fs_fudge_block_bitmap_end(ext2fs_block_bitmap bitmap, blk_t end, blk_t *oend);
extern void ext2fs_clear_inode_bitmap(ext2fs_inode_bitmap bitmap);
extern void ext2fs_clear_block_bitmap(ext2fs_block_bitmap bitmap);
}
function ext2fs_read_bitmaps(fs : Pext2_filsys) : errcode_t; cdecl;
function ext2fs_write_bitmaps(fs : Pext2_filsys): errcode_t; cdecl;

// block.c
function ext2fs_block_iterate(fs : Pext2_filsys; ino : ext2_ino_t; flags : Integer; block_buf : PChar; func : Pointer; priv_data : Pointer) : errcode_t; cdecl;
{errcode_t ext2fs_block_iterate2(ext2_filsys fs, ext2_ino_t ino, int flags, char *block_buf, void *func, void *priv_data);

// bmap.c
extern errcode_t ext2fs_bmap(ext2_filsys fs, ext2_ino_t ino, struct ext2_inode *inode, char *block_buf, int bmap_flags, blk_t block, blk_t *phys_blk);

// check_desc.c
extern errcode_t ext2fs_check_desc(ext2_filsys fs);

//closefs.c
}
function ext2fs_close(fs : Pext2_filsys) : errcode_t; cdecl;
function ext2fs_flush(fs : Pext2_filsys) : errcode_t; cdecl;
{extern int ext2fs_bg_has_super(ext2_filsys fs, int group_block);
extern int ext2fs_super_and_bgd_loc(ext2_filsys fs, dgrp_t group, blk_t *ret_super_blk, blk_t *ret_old_desc_blk, blk_t *ret_new_desc_blk, int *ret_meta_bg);
extern void ext2fs_update_dynamic_rev(ext2_filsys fs);

// cmp_bitmaps.c
extern errcode_t ext2fs_compare_block_bitmap(ext2fs_block_bitmap bm1, ext2fs_block_bitmap bm2);
extern errcode_t ext2fs_compare_inode_bitmap(ext2fs_inode_bitmap bm1, ext2fs_inode_bitmap bm2);

// dblist.c
extern errcode_t ext2fs_get_num_dirs(ext2_filsys fs, ext2_ino_t *ret_num_dirs);
extern errcode_t ext2fs_init_dblist(ext2_filsys fs, ext2_dblist *ret_dblist);
extern errcode_t ext2fs_add_dir_block(ext2_dblist dblist, ext2_ino_t ino, blk_t blk, int blockcnt);
extern void ext2fs_dblist_sort(ext2_dblist dblist, EXT2_QSORT_TYPE func);
extern errcode_t ext2fs_dblist_iterate(ext2_dblist dblist, void *func, void *priv_data);
extern errcode_t ext2fs_set_dir_block(ext2_dblist dblist, ext2_ino_t ino, blk_t blk, int blockcnt);
extern errcode_t ext2fs_copy_dblist(ext2_dblist src, ext2_dblist *dest);
extern int ext2fs_dblist_count(ext2_dblist dblist);

}
// dblist_dir.c
//function ext2fs_dblist_dir_iterate(ext2_dblist dblist, int flags, char *block_buf, void *func, void *priv_data) : errcode_t; cdecl;
{
// dirblock.c
extern errcode_t ext2fs_read_dir_block(ext2_filsys fs, blk_t block, void *buf);
extern errcode_t ext2fs_read_dir_block2(ext2_filsys fs, blk_t block, void *buf, int flags);
extern errcode_t ext2fs_write_dir_block(ext2_filsys fs, blk_t block,	void *buf);
extern errcode_t ext2fs_write_dir_block2(ext2_filsys fs, blk_t block, void *buf, int flags);

// dirhash.c
extern errcode_t ext2fs_dirhash(int version, const char *name, int len, const __u32 *seed, ext2_dirhash_t *ret_hash, ext2_dirhash_t *ret_minor_hash);


// dir_iterate.c
}
type dir_iterate_func = function (dirent : Pext2_dir_entry; offset : Integer; blocksize : Integer; buf : PChar; priv_data : Pointer) : Integer; cdecl;
function ext2fs_dir_iterate(fs : Pext2_filsys; dir : ext2_ino_t; flags : Integer; block_buf : PChar; func : dir_iterate_func; priv_data : Pointer) :  errcode_t; cdecl;
{extern errcode_t ext2fs_dir_iterate2(ext2_filsys fs, ext2_ino_t dir, int flags, char *block_buf, void *func, void *priv_data);

// dupfs.c
extern errcode_t ext2fs_dup_handle(ext2_filsys src, ext2_filsys *dest);
}
// expanddir.c
function ext2fs_expand_dir(fs : Pext2_filsys; dir : ext2_ino_t) : errcode_t; cdecl;
{
// ext_attr.c
extern errcode_t ext2fs_read_ext_attr(ext2_filsys fs, blk_t block, void *buf);
extern errcode_t ext2fs_write_ext_attr(ext2_filsys fs, blk_t block, void *buf);
extern errcode_t ext2fs_adjust_ea_refcount(ext2_filsys fs, blk_t blk, char *block_buf, int adjust, __u32 *newcount);

// fileio.c
extern errcode_t ext2fs_file_open2(ext2_filsys fs, ext2_ino_t ino, struct ext2_inode *inode, int flags, ext2_file_t *ret);}
function ext2fs_file_open(fs : Pext2_filsys; ino : ext2_ino_t; flags : Integer; ret : PPext2_file_t) : errcode_t; cdecl;
{extern ext2_filsys ext2fs_file_get_fs(ext2_file_t file);}
function ext2fs_file_close(fp : Pext2_file_t) : errcode_t; cdecl;
function ext2fs_file_flush(fp: Pext2_file_t) : errcode_t; cdecl;
function ext2fs_file_read(fp : Pext2_file_t; buf : Pointer; wanted : U32; got : PU32) : errcode_t; cdecl;
function ext2fs_file_write(fp : Pext2_file_t; buf : Pointer; nbytes : U32; written : PU32) : errcode_t; cdecl;
function ext2fs_file_llseek(fp : Pext2_file_t; offset : U64; whence : Integer; ret_pos : PU64) : errcode_t; cdecl;
{extern errcode_t ext2fs_file_lseek(ext2_file_t file, ext2_off_t offset, int whence, ext2_off_t *ret_pos);
errcode_t ext2fs_file_get_lsize(ext2_file_t file, __u64 *ret_size);
extern ext2_off_t ext2fs_file_get_size(ext2_file_t file);
extern errcode_t ext2fs_file_set_size(ext2_file_t file, ext2_off_t size);

// finddev.c
extern char *ext2fs_find_block_device(dev_t device);

// flushb.c
extern errcode_t ext2fs_sync_device(int fd, int flushb);

// freefs.c
extern void ext2fs_free(ext2_filsys fs);
extern void ext2fs_free_generic_bitmap(ext2fs_inode_bitmap bitmap);
extern void ext2fs_free_block_bitmap(ext2fs_block_bitmap bitmap);
extern void ext2fs_free_inode_bitmap(ext2fs_inode_bitmap bitmap);
extern void ext2fs_free_dblist(ext2_dblist dblist);
extern void ext2fs_badblocks_list_free(ext2_badblocks_list bb);
extern void ext2fs_u32_list_free(ext2_u32_list bb);

// getsize.c
extern errcode_t ext2fs_get_device_size(const char *file, int blocksize, blk_t *retblocks);

// getsectsize.c
errcode_t ext2fs_get_device_sectsize(const char *file, int *sectsize);

// imager.c
extern errcode_t ext2fs_image_inode_write(ext2_filsys fs, int fd, int flags);
extern errcode_t ext2fs_image_inode_read(ext2_filsys fs, int fd, int flags);
extern errcode_t ext2fs_image_super_write(ext2_filsys fs, int fd, int flags);
extern errcode_t ext2fs_image_super_read(ext2_filsys fs, int fd, int flags);
extern errcode_t ext2fs_image_bitmap_write(ext2_filsys fs, int fd, int flags);
extern errcode_t ext2fs_image_bitmap_read(ext2_filsys fs, int fd, int flags);

// ind_block.c
errcode_t ext2fs_read_ind_block(ext2_filsys fs, blk_t blk, void *buf);
errcode_t ext2fs_write_ind_block(ext2_filsys fs, blk_t blk, void *buf);

// initialize.c
extern errcode_t ext2fs_initialize(const char *name, int flags, struct ext2_super_block *param, io_manager manager, ext2_filsys *ret_fs);

// icount.c
extern void ext2fs_free_icount(ext2_icount_t icount);
extern errcode_t ext2fs_create_icount2(ext2_filsys fs, int flags, unsigned int size, ext2_icount_t hint, ext2_icount_t *ret);
extern errcode_t ext2fs_create_icount(ext2_filsys fs, int flags, unsigned int size, ext2_icount_t *ret);
extern errcode_t ext2fs_icount_fetch(ext2_icount_t icount, ext2_ino_t ino, __u16 *ret);
extern errcode_t ext2fs_icount_increment(ext2_icount_t icount, ext2_ino_t ino, __u16 *ret);
extern errcode_t ext2fs_icount_decrement(ext2_icount_t icount, ext2_ino_t ino, __u16 *ret);
extern errcode_t ext2fs_icount_store(ext2_icount_t icount, ext2_ino_t ino, __u16 count);
extern ext2_ino_t ext2fs_get_icount_size(ext2_icount_t icount);
errcode_t ext2fs_icount_validate(ext2_icount_t icount, FILE *);

// inode.c
extern errcode_t ext2fs_flush_icache(ext2_filsys fs);
extern errcode_t ext2fs_get_next_inode_full(ext2_inode_scan scan, ext2_ino_t *ino, struct ext2_inode *inode, int bufsize);
extern errcode_t ext2fs_open_inode_scan(ext2_filsys fs, int buffer_blocks, ext2_inode_scan *ret_scan);
extern void ext2fs_close_inode_scan(ext2_inode_scan scan);
extern errcode_t ext2fs_get_next_inode(ext2_inode_scan scan, ext2_ino_t *ino, struct ext2_inode *inode);
extern errcode_t ext2fs_inode_scan_goto_blockgroup(ext2_inode_scan scan, int group);
extern void ext2fs_set_inode_callback(ext2_inode_scan scan, void *func, void *done_group_data);
extern int ext2fs_inode_scan_flags(ext2_inode_scan scan, int set_flags, int clear_flags);
}
function ext2fs_read_inode_full(fs : Pext2_filsys; ino : ext2_ino_t; inode : Pext2_inode; bufsize : Integer) : errcode_t; cdecl;
function ext2fs_read_inode(fs : Pext2_filsys; ino : ext2_ino_t; inode : Pext2_inode) : errcode_t; cdecl;

//extern errcode_t ext2fs_write_inode_full(ext2_filsys fs, ext2_ino_t ino, struct ext2_inode * inode, int bufsize);
function ext2fs_write_inode(fs : Pext2_filsys; ino : ext2_ino_t; inode : Pext2_inode) : errcode_t; cdecl;

function ext2fs_write_new_inode(fs : Pext2_filsys; ino : ext2_ino_t; inode : Pext2_inode) : errcode_t; cdecl;
{extern errcode_t ext2fs_get_blocks(ext2_filsys fs, ext2_ino_t ino, blk_t *blocks);
extern errcode_t ext2fs_check_directory(ext2_filsys fs, ext2_ino_t ino);

// inode_io.c
extern io_manager inode_io_manager;
extern errcode_t ext2fs_inode_io_intern(ext2_filsys fs, ext2_ino_t ino, char **name);
extern errcode_t ext2fs_inode_io_intern2(ext2_filsys fs, ext2_ino_t ino, struct ext2_inode *inode, char **name);

// ismounted.c
extern errcode_t ext2fs_check_if_mounted(const char *file, int *mount_flags);
extern errcode_t ext2fs_check_mount_point(const char *device, int *mount_flags, char *mtpt, int mtlen);

// namei.c
extern errcode_t ext2fs_lookup(ext2_filsys fs, ext2_ino_t dir, const char *name, int namelen, char *buf, ext2_ino_t *inode);
extern errcode_t ext2fs_namei(ext2_filsys fs, ext2_ino_t root, ext2_ino_t cwd, const char *name, ext2_ino_t *inode);
errcode_t ext2fs_namei_follow(ext2_filsys fs, ext2_ino_t root, ext2_ino_t cwd, const char *name, ext2_ino_t *inode);
extern errcode_t ext2fs_follow_link(ext2_filsys fs, ext2_ino_t root, ext2_ino_t cwd, ext2_ino_t inode, ext2_ino_t *res_inode);

// native.c
int ext2fs_native_flag(void);

// newdir.c
extern errcode_t ext2fs_new_dir_block(ext2_filsys fs, ext2_ino_t dir_ino, ext2_ino_t parent_ino, char **block);

// mkdir.c}
function ext2fs_mkdir(fs : Pext2_filsys; parent : ext2_ino_t; inum : ext2_ino_t; name : PChar) : errcode_t; cdecl;
{
// mkjournal.c
extern errcode_t ext2fs_create_journal_superblock(ext2_filsys fs, __u32 size, int flags, char  **ret_jsb);
extern errcode_t ext2fs_add_journal_device(ext2_filsys fs, ext2_filsys journal_dev);
extern errcode_t ext2fs_add_journal_inode(ext2_filsys fs, blk_t size, int flags);
}
// openfs.c
function ext2fs_open(name : PChar; flags : Integer; superblock : Integer; blocksize : UINT; io_manager : Pio_manager; fs : PPext2_filsys) : errcode_t; cdecl;
//extern errcode_t ext2fs_open(const char *name, int flags, int superblock, unsigned int block_size, io_manager manager, ext2_filsys *ret_fs);
{extern errcode_t ext2fs_open2(const char *name, const char *io_options, int flags, int superblock, unsigned int block_size, io_manager manager, ext2_filsys *ret_fs);
extern blk_t ext2fs_descriptor_block_loc(ext2_filsys fs, blk_t group_block, dgrp_t i);
errcode_t ext2fs_get_data_io(ext2_filsys fs, io_channel *old_io);
errcode_t ext2fs_set_data_io(ext2_filsys fs, io_channel new_io);
errcode_t ext2fs_rewrite_to_io(ext2_filsys fs, io_channel new_io);

// get_pathname.c
extern errcode_t ext2fs_get_pathname(ext2_filsys fs, ext2_ino_t dir, ext2_ino_t ino, char **name);
}
// link.c
function ext2fs_link(fs : Pext2_filsys; dir : ext2_ino_t; name : PChar; ino : ext2_ino_t; flags : Integer) : errcode_t; cdecl;
function ext2fs_unlink(fs : Pext2_filsys; dir : ext2_ino_t; name : PChar; ino : ext2_ino_t; flags : Integer) : errcode_t; cdecl;
{
// read_bb.c
extern errcode_t ext2fs_read_bb_inode(ext2_filsys fs, ext2_badblocks_list *bb_list);

// read_bb_file.c
extern errcode_t ext2fs_read_bb_FILE2(ext2_filsys fs, FILE *f, ext2_badblocks_list *bb_list, void *priv_data, void *func);
extern errcode_t ext2fs_read_bb_FILE(ext2_filsys fs, FILE *f, ext2_badblocks_list *bb_list, void *func);

// res_gdt.c
extern errcode_t ext2fs_create_resize_inode(ext2_filsys fs);

// rs_bitmap.c
extern errcode_t ext2fs_resize_generic_bitmap(__u32 new_end, __u32 new_real_end, ext2fs_generic_bitmap bmap);
extern errcode_t ext2fs_resize_inode_bitmap(__u32 new_end, __u32 new_real_end, ext2fs_inode_bitmap bmap);
extern errcode_t ext2fs_resize_block_bitmap(__u32 new_end, __u32 new_real_end, ext2fs_block_bitmap bmap);
extern errcode_t ext2fs_copy_bitmap(ext2fs_generic_bitmap src, ext2fs_generic_bitmap *dest);

// swapfs.c
extern void ext2fs_swap_ext_attr(char *to, char *from, int bufsize, int has_header);
extern void ext2fs_swap_super(struct ext2_super_block * super);
extern void ext2fs_swap_group_desc(struct ext2_group_desc *gdp);
extern void ext2fs_swap_inode_full(ext2_filsys fs, struct ext2_inode_large *t, struct ext2_inode_large *f, int hostorder, int bufsize);
extern void ext2fs_swap_inode(ext2_filsys fs,struct ext2_inode *t, struct ext2_inode *f, int hostorder);

// valid_blk.c
extern int ext2fs_inode_has_valid_blocks(struct ext2_inode *inode);

// version.c
extern int ext2fs_parse_version_string(const char *ver_string);}
function ext2fs_get_library_version(ver_string : PPChar; date_string : PPChar) : Integer; cdecl;
{
// write_bb_file.c
extern errcode_t ext2fs_write_bb_FILE(ext2_badblocks_list bb_list, unsigned int flags, FILE *f);
}

function UuidToStr(uuid : array of U8) : String;

implementation

uses sysutils, Debug, winbinfile;

function UuidToStr(uuid : array of U8) : String;
var
   i : Integer;
begin
   Result := '';
   for i := 0 to 15 do
   begin
      Result := Result + IntToHex(uuid[i], 2);
   end;
end;


function ext2fs_new_inode; external 'libext2fs.dll';
function ext2fs_write_new_inode; external 'libext2fs.dll';
function ext2fs_link; external 'libext2fs.dll';
function ext2fs_unlink; external 'libext2fs.dll';
function ext2fs_close; external 'libext2fs.dll';
function ext2fs_flush; external 'libext2fs.dll';
function ext2fs_open; external 'libext2fs.dll';
function ext2fs_get_library_version; external 'libext2fs.dll';
function ext2fs_dir_iterate; external 'libext2fs.dll';
function ext2fs_expand_dir; external 'libext2fs.dll';
function ext2fs_read_inode_full; external 'libext2fs.dll';
function ext2fs_read_inode; external 'libext2fs.dll';
function ext2fs_write_inode; external 'libext2fs.dll';
function ext2fs_file_open; external 'libext2fs.dll';
function ext2fs_file_close; external 'libext2fs.dll';
function ext2fs_file_flush; external 'libext2fs.dll';
function ext2fs_file_read; external 'libext2fs.dll';
function ext2fs_file_write; external 'libext2fs.dll';
function ext2fs_file_llseek; external 'libext2fs.dll';
function ext2fs_mkdir; external 'libext2fs.dll';
function ext2fs_read_bitmaps; external 'libext2fs.dll';
function ext2fs_write_bitmaps; external 'libext2fs.dll';
function ext2fs_block_iterate; external 'libext2fs.dll';

procedure ext2fs_inode_alloc_stats; external 'libext2fs.dll';
procedure ext2fs_block_alloc_stats; external 'libext2fs.dll';



end.
