unit libfat;

interface

uses windows, types, vv_io;

const FILE_ATTR_READ_ONLY            = $01;
const FILE_ATTR_HIDDEN               = $02;
const FILE_ATTR_SYSTEM               = $04;
const FILE_ATTR_SYSHID               = $06;
const FILE_ATTR_VOLUME_ID            = $08;
const FILE_ATTR_DIRECTORY            = $10;
const FILE_ATTR_ARCHIVE              = $20;
const FILE_ATTR_LFN_TEXT             = $0F;
const FILE_HEADER_BLANK              = $00;
const FILE_HEADER_DELETED            = $E5;
const FILE_TYPE_DIR                  = $10;
const FILE_TYPE_FILE                 = $20;

type
   PFatFS = Pointer;
   PPFatFS = ^PFatFS;

   TFatAttr = packed record
    shortname  : PChar;
    longname   : PChar;
    cluster    : U32;
    mtime      : U32;
    ctime      : U32;
    size       : U32;
    attr       : U8;
   end;

   PFatAttr = ^TFatAttr;

   TFatFile = Pointer;
   PFatFile = ^TFatFile;


type dir_iterate_func = function (attr : PFatAttr; priv_data : Pointer) : Integer; cdecl;

function fatfs_open(name : PChar; io_manager : Pio_manager; pfs : PPFatFS) : errcode_t; cdecl;
function fatfs_close(fs : PFatFS) : errcode_t; cdecl;
function fatfs_dump(fs : PFatFS) : errcode_t; cdecl;
function fatfs_list(fs : PFatFS; Cluster : Integer; func : dir_iterate_func; priv_data : Pointer) : errcode_t; cdecl;
function fatfs_open_file(fs : PFatFS; Directory : Integer; FileCluster : Integer; Mode : Integer; Handle : PFatFile) : errcode_t; cdecl;
function fatfs_close_file(fs : PFatFS; Handle : TFatFile) : errcode_t; cdecl;
function fatfs_read_file(fs : PFatFS; Handle : TFatFile; Offset : Integer; Length : Integer; Buffer : Pointer) : errcode_t; cdecl;


implementation

const DLL='libfat.dll';

function fatfs_open; external DLL;
function fatfs_close; external DLL;
function fatfs_dump; external DLL;
function fatfs_list; external DLL;
function fatfs_open_file; external DLL;
function fatfs_close_file; external DLL;
function fatfs_read_file; external DLL;


end.
