#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>

#include "ext2_io.h"
#include "fat.h"

int get_fat_entry(fat_fs_t *fs, unsigned int cluster);

int on_dir_entry(fat_attr_t *attr, void *priv)
{
	printf("0x%02x %-14s %d %d %s\n", attr->attr, attr->shortname, attr->size, attr->cluster, attr->longname ? attr->longname : "");
	return 0;
}

int main(int argc, char **argv)
{
	fat_fs_t *fs;
	fat_file_t *h;
	int i;
	char buffer[4096];

	printf("FAT test code\n");
/*	printf("%d\n", sizeof(U16L));
	printf("%d\n", sizeof(U32L));
	printf("%d\n", sizeof(fat_bpb_t));
	printf("%d\n", sizeof(fat_dirent_t));
	printf("%d\n", sizeof(fat_dirent_long_t));

	printf("%d\n", ((char *)&fs.bpb.BS_jmpBoot) - ((char *)&fs.bpb));
	printf("%d\n", ((char *)&fs.bpb.BS_OEMName) - ((char *)&fs.bpb));
	printf("%d\n", ((char *)&fs.bpb.BPB_BytsPerSec) - ((char *)&fs.bpb));*/

	if(fatfs_open("fat12.img", 0, &fs) == 0)
	{
//		fatfs_dump(fs);
/*for(i = 0; i < 2860; i++)
{
get_fat_entry(fs, i);
}*/
//		fatfs_list(fs, 0, on_dir_entry, 0);
//		dump_cluster(fs, 2763, 512);
//		dump_cluster(fs, 2764, 512);
	}
	if(fatfs_open("fat16.img", 0, &fs) == 0)
	{
//		fatfs_dump(fs);
//		fatfs_list(fs, 0, on_dir_entry, 0);
	}
	if(fatfs_open("fat32.img", 0, &fs) == 0)
	{
		//dump_fs(fs);
		//fatfs_list(fs, 66381, on_dir_entry, 0);
		fatfs_list(fs, 0, on_dir_entry, 0);

		fatfs_open_file(fs, 0, 66404, 0, &h);
//printf("%d\n", h->size);
		fatfs_read_file(fs, h, 0, 100, buffer);
		fatfs_close_file(fs, h);
//		dump_cluster(&fs, 2080, 1067);
		//	dump_cluster_chain(&fs, 2688, 49253);
//		list_directory(&fs, 31438);
//		dump_cluster(&fs, 2688, 4096);
	}

	return 0;
}
