unit about;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls;

type
  TAboutBox = class(TForm)
    OKButton: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Panel2: TPanel;
    ProgramIcon: TImage;
    Label6: TLabel;
    Label7: TLabel;
    ProgramIcon2: TImage;
    Timer1: TTimer;
    PaintBox1: TPaintBox;
    TabSheet3: TTabSheet;
    Credits: TMemo;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Label2Click(Sender: TObject);
    procedure Label2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Label5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    Count : Integer;
  end;

var
  AboutBox: TAboutBox;

implementation

uses ShellAPI, Dialogs, version;

{$R *.DFM}

procedure TAboutBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action := caFree;
end;

procedure TAboutBox.Label2Click(Sender: TObject);
begin
   ShellExecute(Handle, 'open', PChar(TLabel(Sender).Caption), nil, nil, SW_SHOWNORMAL)
end;

procedure TAboutBox.Label2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   TLabel(Sender).Font.Color := clRed;
end;

procedure TAboutBox.Label2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   TLabel(Sender).Font.Color := clBlue;
end;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
   Version.Caption := 'Version ' + AppVersion;
   Memo1.Text := '';
   Memo1.Lines.Add('Virtual Volumes. Copyright (C) 2006 John Newbigin & Chrysocome');
   Memo1.Lines.Add('');
   Memo1.Lines.Add('This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License Version 2 as published by the Free Software Foundation.');
   Memo1.Lines.Add('');
   Memo1.Lines.Add('This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.');
   Memo1.Lines.Add('');
   Memo1.Lines.Add('You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.');

   Memo1.WordWrap := True;

   ProgramIcon2.Left := ProgramIcon.Left;
   ProgramIcon2.Top := ProgramIcon.Top;

   Credits.Text := '';
   Credits.Lines.Add('Virtual Volumes relies on a number of libraries and code samples. Although not required I would like to give some credit to these libraries');
   Credits.Lines.Add('');
   Credits.Lines.Add('e2fsprogs/libext2fs by Theodore Ts''o and others');
   Credits.Lines.Add('This library provides the read/write support for ext2 and ext3');
   Credits.Lines.Add('');
   Credits.Lines.Add('rfsrool by Gerson Kurz');
   Credits.Lines.Add('This provides the base for ReiserFS read support');
   Credits.Lines.Add('');
   Credits.Lines.Add('Thanks to Colin Peters and the MinGW32/MSYS team for a compiler to build the libraries');
   Credits.Lines.Add('');
   Credits.Lines.Add('');
   Credits.Lines.Add('md5 by Matthias Fichtner');
   Credits.Lines.Add('prng by Takuji Nishimura');
   Credits.Lines.Add('win95 thunks by Brian Long?');
   Credits.Lines.Add('win95 Disk IO inspired by The Evil Empire');
   Credits.Lines.Add('FAT filesystem inspired by The Evil Empire');
   Credits.Lines.Add('Ralf Brown''s Interrupt List');
   Credits.Lines.Add('sftp inspired by Simon Tatham');
   Credits.Lines.Add('');
   Credits.Lines.Add('And of course thanks to the millions of Explore2fs users for feedback and support');
   Credits.Lines.Add('');
   Credits.Lines.Add('You too can help by donating at http://www.chrysocome.net/donate');
   Credits.Lines.Add('');

end;

procedure TAboutBox.Label5Click(Sender: TObject);
var
   URL : String;
begin
   URL := 'mailto:' + TLabel(Sender).Caption;
   ShellExecute(Handle, 'open', PChar(URL), nil, nil, SW_SHOWNORMAL)
end;

procedure TAboutBox.Timer1Timer(Sender: TObject);
begin
   ProgramIcon.Visible := True;
   ProgramIcon2.Visible := False;
   Timer1.Enabled := False;
end;

procedure TAboutBox.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
   Count := Count + 1;

   if Count > 100 then
   begin
      Count := 0;
      PaintBox1.Visible := False;
      ProgramIcon2.Visible := True;
      ProgramIcon.Visible := False;
      Timer1.Enabled := True;
   end;
end;

end.

