#include <windows.h>
#include <aclapi.h>
#include <stdio.h>

//----------------------------------------------------------------------
//
// SetCurrentPrivilege
//
// Used to set the privilege necessary for adding computers to domains.
//
//----------------------------------------------------------------------
BOOL SetCurrentPrivilege( LPCTSTR Privilege,  BOOL bEnablePrivilege )
{
    HANDLE hToken;
    TOKEN_PRIVILEGES tp;
    LUID luid;
    TOKEN_PRIVILEGES tpPrevious;
    DWORD cbPrevious=sizeof(TOKEN_PRIVILEGES);
    BOOL bSuccess=FALSE;

    if(!LookupPrivilegeValue(NULL, Privilege, &luid)) return FALSE;

    if(!OpenProcessToken(
            GetCurrentProcess(),
            TOKEN_QUERY | TOKEN_ADJUST_PRIVILEGES,
            &hToken
            )) return FALSE;

    //
    // first pass.  get current privilege setting
    //
    tp.PrivilegeCount           = 1;
    tp.Privileges[0].Luid       = luid;
    tp.Privileges[0].Attributes = 0;

    AdjustTokenPrivileges(
            hToken,
            FALSE,
            &tp,
            sizeof(TOKEN_PRIVILEGES),
            &tpPrevious,
            &cbPrevious
            );

    if(GetLastError() == ERROR_SUCCESS) {
        //
        // second pass.  set privilege based on previous setting
        //
        tpPrevious.PrivilegeCount     = 1;
        tpPrevious.Privileges[0].Luid = luid;
        if(bEnablePrivilege) {
            tpPrevious.Privileges[0].Attributes |= (SE_PRIVILEGE_ENABLED);
        }
        else {
            tpPrevious.Privileges[0].Attributes ^= (SE_PRIVILEGE_ENABLED &
                tpPrevious.Privileges[0].Attributes);
        }

        AdjustTokenPrivileges(
                hToken,
                FALSE,
                &tpPrevious,
                cbPrevious,
                NULL,
                NULL
                );

        if(GetLastError() == ERROR_SUCCESS) bSuccess=TRUE;
    }

    CloseHandle(hToken);

    return bSuccess;
}

void EscelatePrivilege()
{
	SetCurrentPrivilege( SE_SECURITY_NAME,  1);
}

int main(int argc, char **argv)
{
	SECURITY_DESCRIPTOR sd;
	PSID owner;
	BOOL defaulted;

	char *lpszFullName = "\\\\.\\Volume{8e63633e-2813-11da-850b-001485012ae1}";

	PSECURITY_DESCRIPTOR psdSrelFileSD;
        PACL        paclDacl;
        PACL        paclSacl;
        PSID        psidSidOwn;
        PSID        psidSidPG;
	DWORD r;

	EscelatePrivilege();

        r = GetNamedSecurityInfo( lpszFullName, SE_FILE_OBJECT,
                                                (SECURITY_INFORMATION)( OWNER_SECURITY_INFORMATION
                                           | GROUP_SECURITY_INFORMATION
                                           | DACL_SECURITY_INFORMATION
                                           | SACL_SECURITY_INFORMATION),
                                           &psidSidOwn,
                                           &psidSidPG,
                                           &paclDacl,
                                           &paclSacl,
                                           &psdSrelFileSD );
	if(r != ERROR_SUCCESS)
	{
		printf("e = %d\n", r);
                return FALSE;
        }
	printf("Got it\n");
	return 0;
}
