unit strings;

interface

uses classes;

function StartsWith(S : String; Start : String; var Value : String) : Boolean;
function EndsWith(S : String; Ends : String; var Value : String) : Boolean;
function human_size(Size : Int64) : String;
function rpos(Substr: string; S: string) : Integer;
function Tokenise(Command : String; Parameters : TStringList) : Boolean;

implementation

uses sysutils, debug;

function StartsWith(S : String; Start : String; var Value : String) : Boolean;
var
   p : Integer;
begin
   p := Pos(Start, S);
   if p = 1 then
   begin
      Result := True;
      Value := Copy(S, p + Length(Start), Length(S));
   end
   else
   begin
      Result := False;
   end;
end;

function EndsWith(S : String; Ends : String; var Value : String) : Boolean;
begin
   if Copy(S, Length(S) - Length(Ends) + 1, Length(Ends)) = Ends then
   begin
      Result := True;
      Value := Copy(S, 1, Length(S) - Length(Ends));
   end
   else
   begin
      Result := False;
   end;
end;

// only works for a single char substr for now
function rpos(Substr: string; S: string) : Integer;
var
   i : Integer;
begin
   Result := 0;

   for i := Length(S) downto 1 do
   begin
      if S[i] = Substr[1] then
      begin
         Result := i;
         exit;
      end;
   end;
end;


function human_size(Size : Int64) : String;
begin
      Result := IntToStr(Size) + 'b';
exit;
   if Size < 1024 then
   begin
      Result := IntToStr(Size) + 'b';
   end
   else if Size < 1024 * 1024 then
   begin
      Result := IntToStr(Size div 1024) + 'kb';
   end
   else if Size < 1024 * 1024 * 1024 then
   begin
      Result := IntToStr(Size div (1024 * 1024)) + 'Mb';
   end
   else
   begin
      Result := IntToStr(Size div (1024 * 1024 * 1024)) + 'Gb';
   end;
end;

{
   A state based string parser
   0 = normal
   1 = white space
   2 = escape (\) seen
   3 = in '
   5 = in "

}
function Tokenise(Command : String; Parameters : TStringList) : Boolean;
var
   i     : Integer;
   C     : Char;
   State : Integer;
   S     : String;
begin
   Result := True;
   State := 0;
   S := '';
   for i := 1 to Length(Command) do
   begin
      C := Command[i];
      case State of
         0: begin
               if (C = ' ') or (C = #9) then
               begin
                  if Length(S) > 0 then
                  begin
                     Parameters.Add(S);
                     S := '';
                  end;
               //   State := 1; // In White space
               end
               {else if C = '\' then
               begin
                  State := 2; // In Escape
               end}
               else if C = '''' then
               begin
                  State := 3; // In '
                  Result := False;
               end
               else if C = '"' then
               begin
                  State := 5; // In "
                  Result := False;
               end
               else if C = '#' then
               begin
                  break;
               end
               else
               begin
                  S := S + C;
               end;
            end;

         1: begin
               Log('Escapes are NYI');
               State := 1;
            end;

         3: begin
               if C = '''' then
               begin
                  State := 0;
                  Result := True;
               end
               else
               begin
                  S := S + C;
               end;
            end;

         5: begin
               if C = '"' then
               begin
                  State := 0;
                  Result := True;
               end
               else
               begin
                  S := S + C;
               end;
            end;

      end;
   end;
   if Length(S) > 0 then
   begin
      Parameters.Add(S);
      S := '';
   end;

end;


end.
