unit time;

interface

uses Windows, SysUtils;

function CTime(Time : Longint) : String;
function CurrentCTime : ULong;
procedure ctime2filetime(ctime : ULONG; ftime : PFileTime);

implementation

const OFFSET = $019DB1DED53E8000;
const FACTOR = 10000000;

procedure ctime2filetime(ctime : ULONG; ftime : PFileTime);
var
   t : LARGE_INTEGER;
   TZInfo : TTimeZoneInformation;
begin
   GetTimeZoneInformation(TZInfo);
   t.QuadPart := ctime;// - (TZInfo.Bias * 60);
   t.QuadPart := (t.QuadPart * FACTOR) + OFFSET;
   CopyMemory(ftime, @t, sizeof(t));
end;


function CTime(Time : Longint) : String;
var
   Date : TDateTime;
   TZInfo : TTimeZoneInformation;
begin
   GetTimeZoneInformation(TZInfo);
   Date := ((Time - (TZInfo.Bias * 60))/ 86400) + 25569;
   Result := FormatDateTime('dd/mm/yy hh:mm', Date);
end;

function CurrentCTime : ULong;
var
   Date : TDateTime;
   TZInfo : TTimeZoneInformation;
begin
   GetTimeZoneInformation(TZInfo);
   Date := Now;

   Result := Round(((Date - 25569) * 86400) + (TZInfo.Bias * 60));
end;

end.
