unit version;

interface

uses Windows, Forms, Dialogs, SysUtils;

//const AppVersion = '0.3';

  type lplp = ^Pointer;

  TFIXEDFILEINFO2 = packed record
    dwSignature: DWORD;        { e.g. $feef04bd }
    dwStrucVersionLo: WORD;     { e.g. $0000 = "0." }
    dwStrucVersionHi: WORD;     { e.g. $0042 = ".42" }
    dwFileVersionMSLo: WORD;    { e.g. $0003 = "3." }
    dwFileVersionMSHi: WORD;    { e.g. $0075 = ".75" }
    dwFileVersionLS: DWORD;    { e.g. $00000031 = "0.31" }
    dwProductVersionMS: DWORD; { e.g. $00030010 = "3.10" }
    dwProductVersionLS: DWORD; { e.g. $00000031 = "0.31" }
    dwFileFlagsMask: DWORD;    { = $3F for version "0.42" }
    dwFileFlags: DWORD;        { e.g. VFF_DEBUG | VFF_PRERELEASE }
    dwFileOS: DWORD;           { e.g. VOS_DOS_WINDOWS16 }
    dwFileType: DWORD;         { e.g. VFT_DRIVER }
    dwFileSubtype: DWORD;      { e.g. VFT2_DRV_KEYBOARD }
    dwFileDateMS: DWORD;       { e.g. 0 }
    dwFileDateLS: DWORD;       { e.g. 0 }
  end;
  PFIXEDFILEINFO2 = ^TFIXEDFILEINFO2;


function GetFileVersionInfoSize2(lptstrFilename: PAnsiChar; lpdwHandle: LPDWORD): DWORD; stdcall;
function GetFileVersionInfo2(lptstrFilename: PAnsiChar; dwHandle : DWORD; dwLen: DWORD; lpData: Pointer): BOOL; stdcall;
function VerQueryValue2(pBlock: Pointer; lpSubBlock: PAnsiChar; lplpBuffer: lplp; puLen: pUINT): BOOL; stdcall;

function AppVersion : String;

procedure CheckVersion;

implementation

const VERSIONDLL = 'version.dll';

function VerQueryValue2; external VERSIONDLL name 'VerQueryValueA';
function GetFileVersionInfoSize2; external VERSIONDLL name 'GetFileVersionInfoSizeA';
function GetFileVersionInfo2; external VERSIONDLL name 'GetFileVersionInfoA';

procedure CheckVersion;
var
   Handle : DWORD;
   Size   : DWORD;
   Buffer : String;
   Ver : PFIXEDFILEINFO2;
   Len : Integer;
begin
   Size := GetFileVersionInfoSize(PChar(Application.ExeName), Handle);

   if Size > 0 then
   begin
      SetLength(Buffer, Size);
      if GetFileVersionInfo(PChar(Application.ExeName), Handle, Size, PChar(Buffer)) then
      begin
         if VerQueryValue2(PChar(Buffer), '\', @Ver, @Len) then
         begin
            ShowMessage(IntToStr(Ver.dwFileVersionMSHi) + '.' + IntToStr(Ver.dwFileVersionMSLo));
         end;
      end;
   end;
end;

function AppVersion : String;
var
   Handle : DWORD;
   Size   : DWORD;
   Buffer : String;
   Ver : PFIXEDFILEINFO2;
   Len : Integer;
begin
   Result := 'Unknown';

   Size := GetFileVersionInfoSize(PChar(Application.ExeName), Handle);

   if Size > 0 then
   begin
      SetLength(Buffer, Size);
      if GetFileVersionInfo(PChar(Application.ExeName), Handle, Size, PChar(Buffer)) then
      begin
         if VerQueryValue2(PChar(Buffer), '\', @Ver, @Len) then
         begin
            Result := IntToStr(Ver.dwFileVersionMSHi) + '.' + IntToStr(Ver.dwFileVersionMSLo);
         end;
      end;
   end;
end;

end.
