program vv_cmd;
{$APPTYPE CONSOLE}



{$R '\\gw\jnewbigin\working\vv\src\version.res' '\\gw\jnewbigin\working\vv\src\version.rc'}

uses
  SysUtils,
  Classes,
  Windows,
  debug in 'debug.pas',
  vv in 'vv.pas',
  vv_io in 'vv_io.pas',
  libext2fs in '..\lib\libext2fs.pas',
  WinBinFile in 'WinBinFile.pas',
  WinIOCTL in 'WinIOCTL.pas',
  Native in 'Native.pas',
  lvm2 in 'lvm2.pas',
  Unicode in 'Unicode.pas',
  types in 'types.pas',
  vv_common in 'vv_common.pas',
  DiskIO in '95thunk\DiskIO.pas',
  QTThunkU in '95thunk\QTThunkU.pas',
  dmraid in 'dmraid.pas',
  time in 'time.pas',
  vfs_mem in 'vfs_mem.pas',
  vv_loop in 'vv_loop.pas',
  vv_map in 'vv_map.pas',
  vv_win95 in 'vv_win95.pas',
  vv_win32 in 'vv_win32.pas',
  strings in 'strings.pas',
  vfs in 'vfs.pas',
  vfs_ext2 in 'vfs_ext2.pas',
  vfs_win32 in 'vfs_win32.pas',
  winver in 'winver.pas',
  NetLib in 'NetLib.pas',
  vfs_sftp in 'vfs_sftp.pas',
  execute in 'execute.pas',
  ls in 'ls.pas',
  libreiser3 in '..\lib\libreiser3.pas',
  vfs_reiserfs3 in 'vfs_reiserfs3.pas',
  md5 in '..\lib\md5.pas',
  version in 'version.pas',
  libfat in '..\lib\libfat.pas',
  vfs_fat in 'vfs_fat.pas',
  vv_dummy in 'vv_dummy.pas',
  vmdk in 'vmdk.pas',
  vv_part in 'vv_part.pas';

var
   fs2 : TMemFs;
   cmd : String;
   i : Integer;
   Terminate : Boolean;

begin
   // console version
   SetUnicodeConversion(True);
   UseWriteln;

   try

   Setup;

   fs2 := TMemFs.Create;
   Root := fs2.Mount(nil);

   if Assigned(Root) then
   begin
      pwd := Root;
      Terminate := False;

      // script
      if FileExists('init.vv') then
      begin
         process_command('source win32 init.vv');
      end
      else
      begin
         process_command('scan');
      end;

      for i := 1 to ParamCount do
      begin
         if not process_command(ParamStr(i)) then
         begin
            Terminate := True;
         end;
      end;

      while not Terminate do
      begin
         write('[ ' + pwd.Name + ']$ ');
         readln(cmd);
         if not process_command(cmd) then
         begin
            Terminate := True;
         end;
      end;

   end;

   except
      on e : Exception do
      begin
         Log('Exception(' + e.ClassName + ') ' + e.Message);
         Readln;
      end;
   end;

   // any child processes should be killed now
   GenerateConsoleCtrlEvent(CTRL_BREAK_EVENT, 0);
end.
