unit vv_dummy;

interface
uses vv, vfs;

  // A dummy volume which represents a non disk based filesystem
  type TDummyVolume = class(TVirtualVolume)
  public
    function Read(Offset : Int64; Length : Int64; Buffer : Pointer) : Boolean; override;
    function Write(Offset : Int64; Length : Int64; Buffer : Pointer) : Boolean; override;

    function Open(WriteAccess : Boolean) : Boolean; override;
    function Close : Boolean; override;

    function GetLength : Int64; override;
    function IsWritable : Boolean; override;

  end;


implementation

function TDummyVolume.Read(Offset : Int64; Length : Int64; Buffer : Pointer) : Boolean;
begin
   Result := False;
end;

function TDummyVolume.Write(Offset : Int64; Length : Int64; Buffer : Pointer) : Boolean;
begin
   Result := False;
end;

function TDummyVolume.Open(WriteAccess : Boolean) : Boolean;
begin
   Result := False;
end;

function TDummyVolume.Close : Boolean;
begin
   Result := False;
end;

function TDummyVolume.GetLength : Int64;
begin
   Result := 0;
end;

function TDummyVolume.IsWritable : Boolean;
begin
   Result := False;
end;


end.
