unit winver;

interface

function GetVersionString : String;
function OSis95 : Boolean;

implementation

uses Debug, Windows, Sysutils;

var
   Loaded         : Boolean;
   VersionString  : String;
   is95           : Boolean;

procedure LoadWinVer;
var
   Version        : TOSVersionInfo;
//   VersionString  : String;
   OtherBuildNumber : DWORD;
begin
   // find out OS version
   Version.dwOSVersionInfoSize := Sizeof(Version);
   if GetVersionEx(Version) then
   begin
      case Version.dwPlatformId of
         VER_PLATFORM_WIN32s        : VersionString := 'WIN32s';
         VER_PLATFORM_WIN32_WINDOWS : VersionString := 'Windows 95';
         VER_PLATFORM_WIN32_NT      : VersionString := 'Windows NT';
      else
         VersionString := 'Unknown OS';
      end;
      OtherBuildNumber := Version.dwBuildNumber AND $FFFF;
      VersionString := VersionString + ' ' + IntToStr(Version.dwMajorVersion) +
                                       '.' + IntToStr(Version.dwMinorVersion) +
                                       ' build number ' + IntToStr(OtherBuildNumber) +
                                       ' ' + Version.szCSDVersion +
                                       ' (' + IntToStr(Version.dwPlatformId) + ')';
      if OtherBuildNumber <> Version.dwBuildNumber then
      begin
         VersionString := VersionString + ' (' + IntToHex(Version.dwBuildNumber, 8) + ')';
      end;
      Log(VersionString);
      if Version.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS then
      begin
         is95 := True;
      end
      else
      begin
         is95 := False;
      end;
      Loaded := True;
   end;
end;

function GetVersionString : String;
begin
   if not Loaded then
   begin
      LoadWinVer;
   end;
   Result := VersionString;
end;

function OSis95 : Boolean;
begin
   if not Loaded then
   begin
      LoadWinVer;
   end;
   Result := is95;
end;


initialization
   //LoadWinVer;
   Loaded := False;

end.
